
getAnaClrNbrListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        $("#dataRecords").append("<tr id='"+ev.callerNbr+"'></tr>");
        $("#"+ev.callerNbr).append("<td>"+ev.callerNbr+"</td>");
         $("#"+ev.callerNbr).append("<td>"+ev.description+"</td>");
         
        if( null != ev.tranID )
        {
            $("#"+ev.callerNbr).append("<td>"+ev.tranID+"</td>");
        }
        else
        {
            $("#"+ev.callerNbr).append("<td></td>");
        }
        $("#"+ev.callerNbr).append("<td>"+ev.dialPlan+"</td>");        
        
        $("#"+ev.callerNbr).append("<td>"+addBtnEdit(`editAnaCallerNbr('${ev.callerNbr}')`)
                                    +addBtnDel(`delAnaCallerNbr('${ev.callerNbr}')`)
                                    +"</td>");
        
    });
    
};

getAnaClrNbrList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/anaclrnbr/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getAnaClrNbrListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getAnaClrNbrList);
};

gotoNextList=function() {
    pageNext(getAnaClrNbrList);
};

getAnaClrNbrDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#callerNbr").val(ev.callerNbr);
        $("#description").val(ev.description);
        if( null != ev.tranID )
        {
            $("#tranID").val(ev.tranID);
        }
        $("#dialPlan").val(ev.dialPlan);
    });
};

getAnaClrNbrDetail=function(caller_nbr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("callerNbr", caller_nbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/anaclrnbr/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getAnaClrNbrDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateAnaClrNbrDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeString("callerNbr", $("#callerNbr").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeNumber("tranID", $("#tranID").val())+",";
    jsonStr += jsonEncodeString("dialPlan", $("#dialPlan").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/anaclrnbr/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiAnaCallerNbr.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiAnaCallerNbr.html");
        }
    });
};


delAnaCallerNbr=function(caller_nbr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("callerNbr", caller_nbr);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/anaclrnbr/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {           
            $('#'+caller_nbr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};
/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiAnaCallerNbrDlg.html");
};

editAnaCallerNbr=function(caller_nbr) {
    var dataPost = "callerNbr="+encodeURIComponent(caller_nbr);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiAnaCallerNbrDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiAnaCallerNbr.html");
};
