function buildIndexStr(clrNbr) {
    return hex_md5("clrNbr:"+clrNbr);
}

function getClrDispNbrListResp(data)    {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.clrName);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.clrName+"</td>");
        $("#"+indexStr).append("<td>"+ev.displayName+"</td>");
        $("#"+indexStr).append("<td>"+translateBclYesorNo(ev.replaceInd)+"</td>");

        $("#"+indexStr).append("<td>"+addBtnEdit(`editClrDispNbr('${ev.clrName}')`)
                                     +addBtnDel(`delClrDispNbr('${ev.clrName}')`)+"</td>");
    });
}

function getClrDispNbrList()    {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/clrdispnbr/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getClrDispNbrListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
}

function getClrDispNbrDetailResp(data) {
    $.each(data, function(index, ev) {  
    
        $("#clrName").val(ev.clrName);
        $("#displayName").val(ev.displayName);
        setInputCheckAttr("replaceInd", ev.replaceInd);
    });
}

function getClrDispNbrDetail(clrNbr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("clrName", clrNbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/clrdispnbr/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getClrDispNbrDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
}

function updateClrDispNbrDetail() {    
    var jsonStr = "{";
    
    jsonStr += jsonEncodeString("clrName", editBoxValueWithoutSpace('clrName'))+",";
    jsonStr += jsonEncodeString("displayName", editBoxValue('displayName'))+",";
    jsonStr += jsonEncodeBool("replaceInd", checkBoxIntVal("replaceInd"))+",";
        
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/clrdispnbr/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiClrDispNbr.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiClrDispNbr.html");
        }
    });
}

function editClrDispNbr(clrNbr) {
    var dataPost = "clrName="+encodeURIComponent(clrNbr);       
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiClrDispNbrDlg.html");
}

function delClrDispNbr(clrNbr) {
    var indexStr = buildIndexStr(clrNbr);
    var jsonStr = "{";
    jsonStr += jsonEncodeString("clrName", clrNbr);    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/clrdispnbr/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
}

/****************************************************

Functions for UI and Dialog

****************************************************/
function gotoPrevList() {
    pagePrevious(getClrDispNbrList);
}

function gotoNextList() {
    pageNext(getClrDispNbrList);
}

function addBtnOnClick () {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiClrDispNbrDlg.html");
}

function cancelBtnOnClick() {    
    loadHtmlPage("/uiClrDispNbr.html");
}
