buildIndexStr=function(roomID) {
    return hex_md5("roomID:"+roomID);
};

getConfRoomList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/confroom/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getConfRoomListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

getConfRoomListResp=function(data) {
    if( isUndefined(data.errorCode)==false ) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.roomID);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.roomID+"</td>");        
        $("#"+indexStr).append("<td>"+ev.description+"</td>");   
        $("#"+indexStr).append("<td>"+ev.password+"</td>");  
        $("#"+indexStr).append("<td>"+addBtnEdit(`editConfRoom('${ev.roomID}')`)
                                      +addBtnDel(`delConfRoom('${ev.roomID}')`)+"</td>");
    });    
};

gotoPrevList=function () {
    pagePrevious(getConfRoomList);
};

gotoNextList=function() {
    pageNext(getConfRoomList);
};

delConfRoom=function(roomID) {    
    var indexStr = buildIndexStr(roomID);
    var jsonStr = "{";    
    jsonStr += jsonEncodeString("roomID", roomID);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/confroom/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};


getConfRoomDetail=function(roomID) {
    $("#roomID").val(roomID);
    
    var jsonStr = "{";
    jsonStr += jsonEncodeString("roomID", roomID);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/confroom/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getConfRoomDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};


getConfRoomDetailResp=function(data) {
    $.each(data, function(index, ev) {      
        $("#description").val(ev.description);
        $("#password").val(ev.password);
    });
};


updateConfRoomDetail=function() {
    var jsonStr = "{";    
    jsonStr += jsonEncodeString("roomID", editBoxValue('roomID'))+",";    
    jsonStr += jsonEncodeString("description", editBoxValue('description'))+",";
    jsonStr += jsonEncodeString("password", editBoxValue('password'))+",";
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/confroom/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiConfRoom.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiConfRoom.html");
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick=function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiConfRoomDlg.html");
};

editConfRoom=function(roomID) {    
    var dataPost = "roomID="+encodeURIComponent(roomID);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiConfRoomDlg.html");
};

cancelBtnOnClick=function() {    
    loadHtmlPage("/uiConfRoom.html");
};
//EOF
