getPeerServerListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {
        var indexStr = ev.servID;

        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        $("#"+indexStr).append("<td>"+ev.servID+"</td>");
        
        $("#"+indexStr).append("<td>"+ev.desc+"</td>");
        $("#"+indexStr).append("<td>"+ev.servAddr+"</td>");
        $("#"+indexStr).append("<td>"+ev.servPort+"</td>");
        $("#"+indexStr).append("<td>"+translateSipTransport(ev.transport)+"</td>");
        $("#"+indexStr).append("<td>"+addBtnEdit(`editPeerServer(${ev.servID})`)
                                       +addBtnDel(`delPeerServer(${ev.servID})`)+"</td>");
    });
    
};
getPeerServerList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/peerserver/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getPeerServerListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getPeerServerList);
};

gotoNextList=function() {
    pageNext(getPeerServerList);
};

delPeerServer=function(serv_id) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("servID", serv_id);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/peerserver/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {           
            $('#'+serv_id).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

getPeerServerDetailResp=function(data) {
    $.each(data, function(index, ev) {                       
        $("#servID").val(ev.servID);
        $("#desc").val(ev.desc);
        $("#servAddr").val(ev.servAddr);
        $("#servPort").val(ev.servPort);
        $("#callerID").val(ev.callerID);
        $("#reqURIParam").val(ev.reqURIParam);
        $("#dialPlan").val(ev.dialPlan);
        $("#transport").val(ev.transport);
        
        editBoxSetIntValue('ogGroupID',     ev.ogGroupID);
        editBoxSetIntValue('otcID',         ev.otcID);
        editBoxSetIntValue('chainTrunkID',  ev.chainTrunkID);
        editBoxSetIntValue('oMaxCalls',     ev.oMaxCalls);
        editBoxSetIntValue('iMaxCalls',     ev.iMaxCalls);        
        setInputCheckAttr('orelayMediaInd', ev.orelayMediaInd);
        setInputCheckAttr('otelurlInd',     ev.otelurlInd);
    });
};
getPeerServerDetail=function(serv_id) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("servID", serv_id);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/peerserver/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getPeerServerDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updatePeerServerDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeNumber("servID", $("#servID").val())+",";
    jsonStr += jsonEncodeString("desc", $("#desc").val())+",";
    jsonStr += jsonEncodeString("servAddr", $("#servAddr").val())+",";
    jsonStr += jsonEncodeNumber("servPort", $("#servPort").val())+",";
    jsonStr += jsonEncodeString("callerID",     editBoxValue('callerID'))+",";
    jsonStr += jsonEncodeString("reqURIParam",  editBoxValueWithoutSpace('reqURIParam'))+",";
    jsonStr += jsonEncodeString("dialPlan", $("#dialPlan").val())+",";
    jsonStr += jsonEncodeNumber("transport", $("#transport").val())+",";
    jsonStr += jsonEncodeNumber("ogGroupID",    editBoxIntValue('ogGroupID'))+",";
    jsonStr += jsonEncodeNumber("otcID",        editBoxIntValue('otcID'))+",";
    jsonStr += jsonEncodeNumber("chainTrunkID", editBoxIntValue('chainTrunkID'))+",";
    jsonStr += jsonEncodeNumber("oMaxCalls",    editBoxIntValue('oMaxCalls'))+",";
    jsonStr += jsonEncodeNumber("iMaxCalls",    editBoxIntValue('iMaxCalls'))+",";
    
    if( inputHasChecked("orelayMediaInd") ) {
        jsonStr += jsonEncodeNumber("orelayMediaInd",1)+",";
    }
    if( inputHasChecked("otelurlInd") ) {
        jsonStr += jsonEncodeNumber("otelurlInd",1)+",";
    }
    
    jsonStr += jsonEncodeString("endjson", "yes");    
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/peerserver/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiPeerServer.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiPeerServer.html");
        }
    });
};
/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie();
    loadHtmlPage("/uiPeerServerDlg.html");
};

editPeerServer=function(serv_id) {
    var dataPost = "servID="+encodeURIComponent(serv_id);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiPeerServerDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiPeerServer.html");
};
