--=======================================================================
-- miniSipServer Caller prepaid query balance service script
--
-- Copyright (C) MyVoipApp,Inc. All Rights Reserved.
-- 
-- author: Gilson
--
-- History:
-- 2013-01-10 Created
-- 2016-08-01 Migrated from Python script
--=======================================================================
require "services"
require "utils.dba"

--service states
local ECALLER_PREPAID_IDLE         = 0
local ECALLER_PREPAID_WAIT_ANN_END = 1

--default value
local ANN_ID_QUERY_BALANCE = 0x84080005
local TIMER_VAL_WAIT_ANN_END = 30 -- seconds

local balance = 0
local subNbr = ""

--*************************************
--
-- Common functions
--
--*************************************
local function db_caller_prepaid_get_sub_balance()
    local sqlStr = string.format("select nBalance from tbl_sub_balance where cSubName='%s'", subNbr)

    DbPrepare()
    local result = DbQuery(sqlStr)
    if MSS_ERR_OK~=result or 0==DbGetRecordCnts() then
        DbEnd()
        return -1
    end
    DbFetchRow()
    balance = DbGetRowIntVal(0)
    DbEnd()
    return 0
end

local function playBalance()
    local paArg = CreatePA()

    paArg.infoSend_annID_annID = ANN_ID_QUERY_BALANCE
    paArg.infoSend_numOfRepeat = 1
    paArg.infoSend_duration = TIMER_VAL_WAIT_ANN_END

    paArg.infoSend_varType = ESRF_INFO_VAR_PRICE
    paArg.infoSend_var_price = balance
    SendPA(CALLER_LEGID, paArg)
end

--*************************************
--
-- Procedures for messages and states
--
--*************************************

local function onIdleProc(currMsg)
    TraceInfo("CallerPrepaidQuery::onIdleProc")

    subNbr = fsm.callerNbr
    local result = db_caller_prepaid_get_sub_balance()
    if result<0 then
        TraceInfo("\t not a prepaid subscriber")
        EndService()
        return
    end
    TraceInfo("\t balance is "..balance)
    
    SendCTR(CALLER_LEGID)
    playBalance()

    StartTimer(TIMER_VAL_WAIT_ANN_END)
    EnterState(ECALLER_PREPAID_WAIT_ANN_END)
end

local function onWaitAnnEndProc(currMsg)
    TraceInfo("onWaitAnnEndProc")
    EndService()
end


function MainProc(currMsg)
    if fsm.state==ECALLER_PREPAID_IDLE then
        onIdleProc(currMsg)    
    elseif fsm.state==ECALLER_PREPAID_WAIT_ANN_END then
        onWaitAnnEndProc(currMsg)
    else
        TraceInfo("\t unknown state: "..fsm.state)
        EndService()
    end    
end


function DestroyProc()
    TraceInfo("DestroyProc")
    SendReleaseCall()
end
