--=======================================================================
--miniSIPServer Bridge call in one-number service
--
--Copyright (C) MYVOIPAPP,Inc. All Rights Reserved.
--
--author: Gilson
--
--History:
--2015-09-01 created.
--2016-09-14 Migrated from python script
--=======================================================================
require "services"
require "utils.data_string"
require "utils.dba"

--service states
local EOB_CONF_STATE_IDLE = 0

--====================================
--
-- Cache DB functions
--
--====================================
local function cdbGetPeerSSF()
    TraceInfo("\t cdbGetPeerSSF")
    local sqlStr=string.format("select fsmID from tbl_ccf where "..
                 "profileID=%d and callStage=%d limit 1", fsm.profileID, ECALL_TALK)
    local result = cdbQuery(sqlStr)
    if result~=MSS_ERR_OBJ_FOUND then
        TraceInfo("\t\t cannot find target call from cache.")
        return -1
    end

    fsm.peerSSFID = cdbGetRowIntVal(0)
    TraceInfo("\t\t find target SSF ID: "..IntToHexStr(fsm.peerSSFID))
    return 1
end


--====================================
--
-- FSM common functions
--
--====================================
local function initParams()
    fsm.peerSSFID = MSS_INVALID_OBJ_ID
end


local function exceptionProc()
    TraceInfo("\t exceptionProc")
    SendReleaseCall()
    EndService()
end

local function joinCall()
    SendJoinCall(fsm.peerSSFID)
end
--====================================
--
-- FSM state functions
--
--====================================
local function onIdleProc()
    TraceInfo("onenbr_conf: onIdleProc")
    initParams()

    local result = cdbGetPeerSSF()
    if result<0 then
        exceptionProc()
        return
    end

    joinCall()
    EndService()
end


--====================================
--
-- Service main function
--
--====================================
function DestroyProc()
    TraceInfo("DestroyProc")
    -- do nothing
end

function MainProc(currMsg)
    if fsm.state==EOB_CONF_STATE_IDLE then
        onIdleProc()

    else
        TraceInfo("unknown state: "..fsm.state)
        exceptionProc()
    end
end

